/* CVS $Id: $ */
package at.ac.univie.mminf.oai2lod.vocab; 
import com.hp.hpl.jena.rdf.model.*;
 
/**
 * Vocabulary definitions from file:doc/oai2lod-server-config.n3 
 * @author Auto-generated by schemagen on 01 Nov 2008 10:45 
 */
public class OAI2LOD {
    /** <p>The RDF model that holds the vocabulary terms</p> */
    private static Model m_model = ModelFactory.createDefaultModel();
    
    /** <p>The namespace of the vocabulary as a string</p> */
    public static final String NS = "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#";
    
    /** <p>The namespace of the vocabulary as a string</p>
     *  @see #NS */
    public static String getURI() {return NS;}
    
    /** <p>The namespace of the vocabulary as a resource</p> */
    public static final Resource NAMESPACE = m_model.createResource( NS );
    
    /** <p>Base URI for a OAI2LOD Server installation; the URI of the running server's 
     *  start page.</p>
     */
    public static final Property baseURI = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#baseURI" );
    
    /** <p>Another SPARQL endpoint to which this OAI2LOD Server installation is linked 
     *  with</p>
     */
    public static final Property linkedWith = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#linkedWith" );
    
    /** <p>the property for linking two matching resources</p> */
    public static final Property linkingProperty = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#linkingProperty" );
    
    /** <p>A rule specifying the linking conditions</p> */
    public static final Property linkingRule = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#linkingRule" );
    
    /** <p>The maximum number of records to be harvested from an OAI-PMH Server.</p> */
    public static final Property maxRecords = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#maxRecords" );
    
    /** <p>The maximum number of results when sending a SPARQL query (used for LIMIT 
     *  clause)</p>
     */
    public static final Property maxResults = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#maxResults" );
    
    /** <p>The metadata prefix denoting the format of the records to be harvested.</p> */
    public static final Property metadataPrefix = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#metadataPrefix" );
    
    /** <p>The minimum similarity two strings must have for being considered equal.</p> */
    public static final Property minSimilarity = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#minSimilarity" );
    
    /** <p>The TCP port on which a OAI2LOD Server installation listens.</p> */
    public static final Property port = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#port" );
    
    /** <p>The OAI-PMH endpoint that is published by a D2R Server installation.</p> */
    public static final Property publishes = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#publishes" );
    
    /** <p>The URL endpoint of the OAI-PMH Server.</p> */
    public static final Property serverURL = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#serverURL" );
    
    /** <p>The Java class which implements the algorithm used for calculating the similarity 
     *  metrics (e.g., Levensthein).</p>
     */
    public static final Property similarityMetrics = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#similarityMetrics" );
    
    /** <p>The property to be considered in an instance in the OAI2LOD Server data set</p> */
    public static final Property sourceProperty = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#sourceProperty" );
    
    /** <p>The rdf:type of an instance in the OAI2LOD Server data set</p> */
    public static final Property sourceType = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#sourceType" );
    
    /** <p>The endpoint (URI) of the SPARQL service to be linked</p> */
    public static final Property sparqlService = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#sparqlService" );
    
    /** <p>The location (path) of the stylesheet to be used for transforming XML records 
     *  into RDF/XML.</p>
     */
    public static final Property styleSheet = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#styleSheet" );
    
    /** <p>The property to be considered in an instance in the target data set</p> */
    public static final Property targetProperty = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#targetProperty" );
    
    /** <p>The rdf:type of an instance in the target data set</p> */
    public static final Property targetType = m_model.createProperty( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#targetType" );
    
    /** <p>Specification of a SPARQL endpoint to be linked</p> */
    public static final Resource LinkedSPARQLEndpoint = m_model.createResource( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#LinkedSPARQLEndpoint" );
    
    /** <p>Defines a condition for linking data sets</p> */
    public static final Resource LinkingRule = m_model.createResource( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#LinkingRule" );
    
    /** <p>A configuration for an OAI-PMH Harvesting Job.</p> */
    public static final Resource OAIServer = m_model.createResource( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#OAIServer" );
    
    /** <p>A configuration for a OAI2LOD Server installation.</p> */
    public static final Resource Server = m_model.createResource( "http://www.mediaspaces.info/vocab/oai2lod-server-config.rdf#Server" );
    
}
